
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/dos.h>
#include <proto/datatypes.h>
#include <datatypes/soundclass.h>


int main (int argc,char *argv[])

{
struct RDArgs *rdargs;
static struct {
	char *from;
	long *delay;
	} args = {"sys:prefs/presets/sounds/dong.wav"};

Object *o1,*o2,*o3,*o4;
LONG sign1,sign2,sign3,sign4;
ULONG sig1,sig2,sig3,sig4;
ULONG sigs;
long n;

if (rdargs = ReadArgs ("FROM,DELAY/N",(APTR)&args,NULL))
	{

	sign1 = AllocSignal (-1);
	sign2 = AllocSignal (-1);
	sign3 = AllocSignal (-1);
	sign4 = AllocSignal (-1);

	if (sign1 != -1 && sign2 != -1 && sign3 != -1 && sign4 != -1)
		{
		sig1 = 1L << sign1;
		sig2 = 1L << sign2;
		sig3 = 1L << sign3;
		sig4 = 1L << sign4;

		o1 = NewDTObject (args.from,DTA_GroupID,GID_SOUND,SDTA_SignalTask,FindTask(NULL),SDTA_SignalBit,sig1,TAG_END);
		o2 = NewDTObject (args.from,DTA_GroupID,GID_SOUND,SDTA_SignalTask,FindTask(NULL),SDTA_SignalBit,sig2,TAG_END);
		o3 = NewDTObject (args.from,DTA_GroupID,GID_SOUND,SDTA_SignalTask,FindTask(NULL),SDTA_SignalBit,sig3,TAG_END);
		o4 = NewDTObject (args.from,DTA_GroupID,GID_SOUND,SDTA_SignalTask,FindTask(NULL),SDTA_SignalBit,sig4,TAG_END);

		if (o1 && o2 && o3 && o4)
			{
			DoMethod (o1,DTM_TRIGGER,NULL,STM_PLAY,NULL);
			Delay (args.delay ? *args.delay : 20);
			DoMethod (o2,DTM_TRIGGER,NULL,STM_PLAY,NULL);
			Delay (args.delay ? *args.delay : 20);
			DoMethod (o3,DTM_TRIGGER,NULL,STM_PLAY,NULL);
			Delay (args.delay ? *args.delay : 20);
			DoMethod (o4,DTM_TRIGGER,NULL,STM_PLAY,NULL);

			do	{
				Printf ("waiting for loop\n");
				sigs = Wait (sig1 | sig2 | sig3 | sig4 | SIGBREAKF_CTRL_C);
				if (sigs & sig1)
					{
					Printf ("repeating voice 1\n");
					DoMethod (o1,DTM_TRIGGER,NULL,STM_PLAY,NULL);
					}
				if (sigs & sig2)
					{
					Printf ("repeating voice 2\n");
					DoMethod (o2,DTM_TRIGGER,NULL,STM_PLAY,NULL);
					}
				if (sigs & sig3)
					{
					Printf ("repeating voice 3\n");
					DoMethod (o3,DTM_TRIGGER,NULL,STM_PLAY,NULL);
					}
				if (sigs & sig4)
					{
					Printf ("repeating voice 4\n");
					DoMethod (o4,DTM_TRIGGER,NULL,STM_PLAY,NULL);
					}
				}
			while (!(sigs & SIGBREAKF_CTRL_C));

			n = 0;
			do	{
				Printf ("waiting for sounds to finish. %ld to go\n",4-n);
				sigs = Wait (sig1 | sig2 | sig3 | sig4 | SIGBREAKF_CTRL_C);
				n ++;
				}
			while (n < 4);
			}

		if (o1) DisposeDTObject (o1);
		if (o2) DisposeDTObject (o2);
		if (o3) DisposeDTObject (o3);
		if (o4) DisposeDTObject (o4);
		}

	if (sign1 != -1) FreeSignal (sign1);
	if (sign2 != -1) FreeSignal (sign2);
	if (sign3 != -1) FreeSignal (sign3);
	if (sign4 != -1) FreeSignal (sign4);

	FreeArgs (rdargs);
	}

PrintFault (IoErr(),NULL);

return(0);
}

